
 ;slot by vincent daubry(GANDALF)

 include "tios.h" ;include file containing the ROM functions(the semicolon " ; " after any statement in a program defines a comment. This is completely ignored in the compiler) 
 include "util.h" ;util library ( This library also includes ROM CALL , for example it includes the keyboard input and clear screen functions).

 xdef _main ;This defines the entry point of the prog
 xdef _comment ;tells the assembler that a program comment exists(it doesn't appears in the programm itself but can be seen with fileedit,plusshell browser or doorsos explorer)  
 xdef _ti89 ;specify which calculators this program will run on.

WriteStr  MACRO ;write string macro
          move.w \3,-(a7) ;color
          pea \4 ;push string adress into the stack
          move.w \2,-(a7) ;y coordonate
          move.w \1,-(a7) ;X coordonate
          jsr tios::DrawStrXY ;draw the string(DrawStrXY : x , y, string , color )
          add    #10,a7 ;restore the stack(w=2 pea=4 : 2+2+2+4=10)
          ENDM ;end macro
        
WriteChar  MACRO ;draw character macro
          move.w \1,-(a7) ;X coordonate
          move.w \2,-(a7) ;y coordonate
          move.w \3,-(a7) ;color
          move.w d0,-(a7) ;printed character's scan code 
          jsr    util::DrawCharXY ;draw the character
          add    #8,a7 ;restore the stack(w=2 : 2+2+2+2=8)
          ENDM

_main: ; prints the intro
 jsr      util::zap_screen ;call the ROM CALL contained in util which clears the screen
 WriteStr #50,#25,#4,intro ;write the intro(/4) string at x(/1)=35 y(/2)=25 color(/4)=4 
 move.w   #2,-(a7) ;set the ROM CALL argument : bold font
 jsr      tios::FontSetSys ;call the ROM function FontSetSys contained in the tios which changes the font
 add.w    #2,a7 ;restore stack(w=2)
 WriteStr #35,#45,#4,intro2
 jsr      util::idle_loop ;wait for any key to be pressed, then returns to the program and stores the scan code in d0

menu_management: ; manages the menu
 jsr      util::zap_screen
 move.w   #1,-(a7) ;set normal font
 jsr      tios::FontSetSys
 add.w    #2,a7
 move.w   #50,money ;#50 pushed into money variable
 WriteStr #0,#10,#4,menu
 WriteStr #0,#30,#4,menu1
 WriteStr #0,#50,#4,menu2
 WriteStr #0,#70,#4,menu3
 WriteStr #0,#90,#4,version
 jsr      util::idle_loop
 cmp      #49,d0 ;compare the scan code(=d0) and the scan code #49(=1)
 beq      loop ;if equal branch to the loop label
 cmp      #50,d0 ;scan code #50=2
 beq      thanks
 cmp      #51,d0 ;scan code #51=3
 beq      how
 cmp      #52,d0 ;scan code #52=4
 beq      exit2
 cmp      #264,d0 ;scan code #264=esc
 beq      exit2
 bra      menu_management ;if none of those key is pressed,start again
   
loop: ; beginning of the game : prints the first screen and defines the random number
 jsr      util::zap_screen 
 WriteStr #30,#35,#4,bucks
 move.w   money,-(a7) ;push in the stack the number to convert (ROM CALL arguments)
 pea      format ;push the format string in the stack which contains the routine's arguments (ROM CALL arguments)
 pea      buffer ;push in the stack the string where the converted number will be stored (ROM CALL arguments)
 Jsr      _ROM_CALL_53 ;call the routine which convert the money var stored in the stack and store it in the buffer string
 add      #10,a7 ;restore the stack (2+4+4)
 WriteStr #100,#35,#4,buffer ;write the buffer string
 jsr      util::idle_loop
 cmp      #264,d0
 beq      exit1
 move.b   #10,d0 ;D0 = range : 10 numbers (random number will be chosen between 0 and 9 ) 
 jsr      util::random ;library routine which chooses a number
 add      #48,d0 ;turn the chosen random number(d0) into his scan code by adding to itself #48 (warning:it only works with these numbers!:1-9)  
 move.w   d0,d5 ;save the chosen random number(d0) scan code in d5
 move.w   #5,d4 ;default bet
 jsr      util::zap_screen
 WriteStr #15,#35,#4,bet
 
loop2: ; prints the bet screen and the actual bet
 move.w   d4,-(a7) ;move the default bet in d0,which will be converted in a string stored in a0
 pea      format ;push the format string in the stack which contains the routine's arguments
 pea      buffer1 ;push in the stack the string where the converted number will be stored
 jsr      _ROM_CALL_53 ;call the routine which convert the bet value stored in the stack and store it in the buffer1 string
 add      #10,a7;restore the stack (2+4+4)
 WriteStr #40,#50,#4,buffer1 ;write the buffer1 string containing the converted number

getkey: ; tests if u bet more or less
 jsr      util::idle_loop 
 cmp      #340,d0 ;scan code #340 = down
 beq      down
 cmp      #337,d0 ;scan code #337 = up
 beq      up
 cmp      #13,d0 ;scan code #13 = enter (return to the game routine)
 beq      game
 cmp      #263,d0 ;scan code #263 = clear
 bne      loop2 ;if this key isn't pressed,return to loop2 and test the getkey one more time(none of the previous key has been pressed)
 trap     #4 ;if clear key is pressed turn off the calc
 bra      loop2 ;when the calc is turned on,go to loop2 and test the getkey one more time

down: ;decreases the bet
 tst      d4 ;u can't bet less than 0
 beq      loop2 ;if u try u must enter something else
 sub.w    #5,d4 ;sub 5 to what u've bet
 bra      loop2
 
up: ;increases the bet
 cmp      money,d4 ;compare what u have to what u've bet
 beq      loop2 ;u can't bet more than what u have
 add.w    #5,d4 ;add 5 to what u've bet
 bra      loop2
 
game: ;tests if u've won or not
 jsr      util::zap_screen
 WriteStr #35,#35,#4,question
 jsr      util::idle_loop
 cmp      d0,d5 ;compare the number which u've bet on to the chosen random number 
 beq      win ;if equal , u win , if not it goes to lost

lost: ;lost screen and gane over test
 sub      d4,money ;u loose what u have bet
 jsr      util::zap_screen
 WriteStr #35,#20,#4,lost1
 WriteStr #15,#35,#4,good
 move.w   d5,d0 ;move the chosen random number scan code in d0 which will be displayed
 WriteChar #2,#55,#65
 jsr      util::idle_loop
 cmp      #0,money ;if u don't have any money left u loose
 beq      exit1
 bra      loop ;if u do , start a new game
 
win: ;win screen
 mulu     #10,d4 ;if u've won,add ten times what u've bet to your money
 add      d4,money
 jsr      util::zap_screen
 WriteStr #55,#20,#4,won
 jsr      util::idle_loop
 bra      loop ;start a new game

exit1: ;exit question
 jsr      util::zap_screen
 WriteStr #40,#20,#4,end1
 WriteStr #0,#40,#4,end2
 jsr      util::idle_loop
 cmp      #110,d0
 beq      exit2
 cmp      #54,d0
 beq      exit2
 cmp      #121,d0
 beq      _main
 bra      exit1
 
exit2 ;exit screen
 jsr      util::zap_screen
 move.w   #0,-(a7) ;set small font
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#15,#4,contact
 WriteStr #0,#25,#4,contact1
 WriteStr #0,#35,#4,contact2
 jsr      util::idle_loop
 rts ;the calc returns to the tios (program is ended)

thanks: ;thanks screen
 jsr      util::zap_screen
 move.w   #0,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#15,#4,laurent
 WriteStr #0,#30,#4,michou
 WriteStr #0,#45,#4,kenny
 WriteStr #0,#60,#4,doc
 jsr      util::idle_loop
 jsr      util::zap_screen
 WriteStr #0,#15,#4,jah
 WriteStr #0,#30,#4,misc
 WriteStr #0,#45,#4,misc2 
 jsr      util::idle_loop
 move.w   #1,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 bra      _main
 
how: ;how to play screen
 jsr      util::zap_screen
 move.w   #0,-(a7)
 jsr      tios::FontSetSys
 add.w    #2,a7
 WriteStr #0,#0,#4,rules
 WriteStr #0,#15,#4,rules2
 WriteStr #0,#30,#4,rules3
 WriteStr #0,#45,#4,rules4
 WriteStr #0,#60,#4,rules5
 WriteStr #0,#75,#4,rules6
 WriteStr #0,#90,#4,rules7
 jsr      util::idle_loop
 move.w   #1,-(a7) ;set normal font
 jsr      tios::FontSetSys
 add.w    #2,a7
 bra      _main

 ; STRING AND VARIABLES DECLARATION :

money     dc.w  0   ;money is a var that is the length of a word and starts at 0
contact   dc.b  "If u notice any bug or if u have any",0;"dc" stands for declare and ".b" is the size(Strings can only be a byte) : some space is allowed to the string in the memory. The zero lets the compiler know the string has ended
contact1  dc.b  "questions or comments , please mail me at:",0
contact2  dc.b  "Ric.Daubry@wanadoo.fr",0
laurent   dc.b  ".Spike : who introduced me to asm",0
michou    dc.b  ".Angelo : who made me bought my ti89",0
kenny     dc.b  ".Kenny , Doc.b , Etienne : for support",0 
doc       dc.b  ".Thibault , Chti : for support",0
jah       dc.b  ".Jah (of course)",0
misc      dc.b  ".Razmig , Benji : for support",0
misc2     dc.b  ".Mathieu , Magnum44 , Thomas : for support",0
menu      dc.b  "1   Play",0
menu1     dc.b  "2   Thanks",0
menu2     dc.b  "3   How to play?",0
menu3     dc.b  "4   Quit",0
end1      dc.b  "GAME OVER",0
end2      dc.b  "Do u want another go?(y/n)",0
intro     dc.b  "Slot",0
intro2    dc.b  "by gandalf",0
question  dc.b  "Choose a number",0
won       dc.b  "You've won",0
lost1     dc.b  "You've lost",0
bet       dc.b  "How much do you bet?",0
good      dc.b  "The right number was:",0
bucks     dc.b  "You have:",0
version   dc.b  "v 1.2",0
rules     dc.b  "First , choose how much u bet with the up",0
rules2    dc.b  "and down key.",0
rules3    dc.b  "Then , press the number u want to bet on(0-9).",0
rules4    dc.b  "If u're wrong , u loose what u've bet.",0
rules5    dc.b  "Otherwise , u win 10 times what u've bet.",0
rules6    dc.b  "U can exit with the esc button and shut down",0
rules7    dc.b  "the calc with the clear button",0
format    dc.b  "%d",0 ;the "%" means that the following charactere are arguments , the "d" lets the routine know that the number to convert is decimal
buffer    dc.b  "   ",0 ;string where the converted money var will be stored
buffer1   dc.b  "   ",0;string where the converted bet will be stored

_comment: dc.b  " slot game by gandalf ",0 ;can be seen with fileedit,plusshell browser or doorsos explorer at the very end of the prog

 end ;This lets the compiler know that the source code has ended(how surprising! :) )
